LABEL bookmove

* BookMove: Return a randomized move from the opening book. If no book moves
* are available the NULL$ is returned.

( :: CK3&Dispatch # 333 ) ( MOVES BRD INFO -> MOVES BRD INFO bookmove )

::
  $_:: TOTEMPOB
  INCLUDE mlbook.s
  CODE
* Input: MOVES BRD INFO bookmove book
	GOSBVL	save_regs

	D1=D1+	10
	A=DAT1	A
	LC(5)   G_EPSNT
	A=A+C	A
	D0=A
	C=DAT0	B
	B=C	A		; B.B = G_EPSNT
	LC(5)   (EPSNT)-(G_EPSNT)
	A=A+C	A
	D0=A
	C=B	A
	DAT0=C	B		; EPSNT = B.B
	D1=D1-	10

	C=DAT1	A
	C=C+CON A,10
	R1=C			; R1 = ptr to book

	D1=D1+	10
	A=DAT1	A
	LC(5)   FLAGS
	C=C+A	A
	D0=C
	C=DAT0	B
	?CBIT=1 NORMALSTART
	GOYES	+
	GOTO	not_found	; If not normal start, don't use book

+	D1=D1+	10
	C=DAT1	A
	D0=C
	D0=D0+	5
	C=DAT0	A
	C=C-CON A,5
	D=C	A		; D = nibbs remaining from MOVES
	D0=D0+	5
	CD0EX
	C=C+D	A
	R0=C			; R0 = ptr to MOVES
	D1=D1-	15		; D1 -> bookmove

bk_loop ?D#0	A
	GOYES	+
	GOTO	found_pos
+	C=R0
	C=C-CON A,8
	D0=C
	R0=C			; R0 -= 8

	C=0	A
	LC(2)   #21
	B=C	A

	C=DAT0	B
	C=C-B	A
	C=C+C	P		; C = from << 1

	D0=D0+	2
	A=DAT0	B
	A=A-B	A
	A=A+A	P
	ASRB.F	B		; A = to

	CSL	A
	C=C+C	A
	C=C!A	B
	B=C	A		; B = from << 6 + to

	C=R1
	D0=C
	C=0	A
loop2	C=DAT0	3
	?C#0	A
	GOYES	+
	GOTO	not_found
+	?B=C	A
	GOYES	book_found
	D0=D0+	6
	GOTO	loop2

book_found
	D0=D0+	3
	C=DAT0	3
	A=C	A
	C=C+A	A
	C=C+A	A
	C=C+C	A
	D0=D0-	3
	AD0EX
	C=C+A	A
	R1=C			; R1 += 6*offset (move to next position)

	D=D-CON A,8
	GOTO	bk_loop

* Found board position in opening book. Now select a random book move.
found_pos
	B=0	A
	C=R1
	D0=C

	C=0	A
loop3	C=DAT0	3
	D0=D0+	6
	B=B+1	A
	?C#0	A
	GOYES	loop3
	B=B-1	A		; B = # of moves to choose from
	?B=0	A
	GOYES	not_found

	D0=(5)  =CRC
	C=0	A
	C=DAT0	B
loop4	?C<B	A
	GOYES	+
	C=C-B	B
	GONC	loop4		; Always true
+	A=C	A
	A=A+C	A
	A=A+C	A
	A=A+A	A		; A = 6*rand(B)
	C=R1
	C=C+A	A
	D0=C
	C=0	A
	C=DAT0	3		; C = selected move

	A=DAT1	A
	D0=A
	D0=D0+	10		; D0 -> bookmove

	LA(2)   #21
	B=A	A

	LA(2)   #3F
	A=A&C	A
	A=A+A	A
	ASRB.F	P
	A=A+B	A
	CSR	A
	CSRB.F	A
	CSRB.F	P
	C=C+B	A
	DAT0=C	B		; bookmove[0] = from
	D0=D0+	2
	DAT0=A	B		; bookmove[1] = to

not_found
	GOVLNG	rest_loop
  ENDCODE
  DROP				  ( MOVES BRD INFO bookmove )
  UNROT
  CODE
    CALL  genmoves
  ENDCODE
  4ROLL ZERO			  ( MOVES BRD INFO movelist bookmove pos )
  BEGIN
    #1+ UNROT 2DUP5ROLL POS$ DUP #1- EIGHT #/ DROP #0= OVER#0= OR
  UNTIL
  DUP#0=case :: 3DROP NULL$ ;
  SWAPDROP DUP #3+ SUB$
;
