	IFDEF	HP49
	INCLUDE SupRomEntr_49.a
	ELSE
	INCLUDE SupRomEntr_48.a
	ENDIF

STRUCT	MACRO			; structure name, initial offset
$1	EQU	0
SOFFSET =	$2
	ENDM

BYTE	MACRO			; (2 nibbles)
$1	EQU	SOFFSET
SOFFSET =	(SOFFSET)+2
	ENDM

INT	MACRO			; (5 nibbles)
$1	EQU	SOFFSET
SOFFSET =	(SOFFSET)+5
	ENDM

INT_B	MACRO			; (5 nibbles)
$1	EQU	SOFFSET
SOFFSET =	(SOFFSET)+6     ; BYTE-alignment
	ENDM

WORD	MACRO			; (4 nibbles)
$1	EQU	SOFFSET
SOFFSET =	(SOFFSET)+4
	ENDM

LONG	MACRO			; (8 nibbles)
$1	EQU	SOFFSET
SOFFSET =	(SOFFSET)+8
	ENDM

NIB	MACRO			; (1 nibble)
$1	EQU	SOFFSET
SOFFSET =	(SOFFSET)+1
	ENDM

NIB3	MACRO			; (3 nibbles)
$1	EQU	SOFFSET
SOFFSET =	(SOFFSET)+3
	ENDM

LCaddr	MACRO			; label
	C=PC
LCa_$0	LA(5)   ($1)-(LCa_$0)
	C=C+A	A
	ENDM

LAaddr	MACRO			; label
	C=PC
LAa_$0	LA(5)   ($1)-(LAa_$0)
	A=A+C	A
	ENDM


    STRUCT Info,10		; 10 nibbles of string header
	BYTE	VKNG		; White king position
	BYTE	SKNG		; Black king position
	INT_B	VMTL		; Total value of white pieces
	INT_B	SMTL		;		 black pieces
	BYTE	PLY		; Current search depth
	BYTE	Depth		; Search depth
	BYTE	EXTDEPTH	; Extended search depth (capture)
	BYTE	COL		; Current color (1)
	BYTE	EPSNT		; Passant square (or 0)
	INT_B	HI		; Best score so far
	INT_B	GOAL		; Goal score (beta)
	BYTE	LEGAL		; Number of legal moves
	INT_B	GLSCORE 	; Global score
	BYTE	TOA1		; Number of moves to A1 and E1
	BYTE	TOH1		;		     H1     E1
	BYTE	TOA8		;		     A8     E8
	BYTE	TOH8		;		     H8     E8

	BYTE	FLAGS		; See below
	BYTE	MOVENUM 	; Current move number
	BYTE	G_DEPTH 	; Global search depth. Copied to DEPTH before
				;   FINDBEST call
	BYTE	G_EXTDEPTH	; Global extended depth.
	BYTE	G_EPSNT 	; Passant square for the on-screen position.

	LONG	MOVE1		; Best move at PLY=1

MOVE0	EQU	(MOVE1)-8

* The fields in the FLAGS byte.

BOARDFLIP	EQU	0
NORMALSTART	EQU	1
OLDPIECES	EQU	2

* Assembler entry points

save_regs EQU	SAVPTR
rest_regs EQU	GETPTR
rest_loop EQU	GETPTRLOOP
make_str  EQU	MAKE$N

* Status register usage

WhiteFlag EQU	0

* Constants

INFTY	EQU	50000
