LABEL drawboard

( :: CK2&Dispatch FIFTYONE ) ( BRD INFO )

CODE
* Input: BRD INFO	    Draw the board with all pieces
	GOSBVL	save_regs

	D1=D1+	5		; D1 -> BRD
	LC(5)   #21

-	R1=C
	GOSUB	squpd
	C=R1
	C=C+1	A
	LA(2)   #99
	?C<A	B
	GOYES	-

	GOVLNG	rest_loop

********************************************************************
* squpd: Update a square on the display
*
* Input:  D1   = BRD
*	  R1.A = square
*
* Destroys: A,B,C,D,D0,R0

squpd	C=R1
	B=C	A		; B = square

	A=DAT1	A
	A=A+B	A
	A=A+B	A
	AD0EX
	D0=D0+	10
	C=DAT0	B

	D=C	B		; D = piece
	LC(2)   7
	?D=C	B
	RTNYES			; Don't draw outside board
	GOSUB	+

piecedata_new
	NIBHEX	0000000000000000		; Empty	       on white square
	NIBHEX	0000C12222414122		; White pawn   on white square
	NIBHEX	8043241817211204		; White knight on white square
	NIBHEX	8142252442242424		; White bishop on white square
	NIBHEX	0055142222222214		; White rook   on white square
	NIBHEX	00AA142241412214		; White queen  on white square
	NIBHEX	4177147741412214		; White king   on white square

	NIBHEX	FFFFFFFFFFFFFFFF		; Empty        on black square
	NIBHEX	FFFF7E3C3C7E7E3C		; White pawn   on black square
	NIBHEX	FF7F3C181F3F1E0C		; White knight on black square
	NIBHEX	7F3E1D9C3E1C1C1C		; White bishop on black square
	NIBHEX	FF5D1C3E3E3E3E1C		; White rook   on black square
	NIBHEX	FFAA1C3E7F7F3E1C		; White queen  on black square
	NIBHEX	7F7F1C7F7F7F3E1C		; White king   on black square

	NIBHEX	0000000000000000		; Empty        on white square
	NIBHEX	000081C3C38181C3		; Black pawn   on white square
	NIBHEX	0080C3E7E0C0E1F3		; Black knight on white square
	NIBHEX	80C1E263C1E3E3E3		; Black bishop on white square
	NIBHEX	00A2E3C1C1C1C1E3		; Black rook   on white square
	NIBHEX	0055E3C18080C1E3		; Black queen  on white square
	NIBHEX	8080E3808080C1E3		; Black king   on white square

	NIBHEX	FFFFFFFFFFFFFFFF		; Empty        on black square
	NIBHEX	FFFF3EDDDDBEBEDD		; Black pawn   on black square
	NIBHEX	7FBCDBE7E8DEEDFB		; Black knight on black square
	NIBHEX	7EBDDADBBDDBDBDB		; Black bishop on black square
	NIBHEX	FFAAEBDDDDDDDDEB		; Black rook   on black square
	NIBHEX	FF55EBDDBEBEDDEB		; Black queen  on black square
	NIBHEX	BE88EB88BEBEDDEB		; Black king   on black square

piecedata_old
	NIBHEX	0000000000000000		; Empty	       on white square
	NIBHEX	0000C3424242C300		; White pawn   on white square
	NIBHEX	00C366242764C700		; White knight on white square
	NIBHEX	00C143426624E700		; White bishop on white square
	NIBHEX	00E7A5242424E700		; White rook   on white square
	NIBHEX	00E7A5662424E700		; White queen  on white square
	NIBHEX	00C366246624E700		; White king   on white square

	NIBHEX	FFFFFFFFFFFFFFFF		; Empty        on black square
	NIBHEX	FFFFFF7E7E7EFFFF		; White pawn   on black square
	NIBHEX	FFFF7E3C3F7CFFFF		; White knight on black square
	NIBHEX	FFFF7F7E7E3CFFFF		; White bishop on black square
	NIBHEX	FFFFBD3C3C3CFFFF		; White rook   on black square
	NIBHEX	FFFFBD7E3C3CFFFF		; White queen  on black square
	NIBHEX	FFFF7E3C7E3CFFFF		; White king   on black square

	NIBHEX	0000000000000000		; Empty        on white square
	NIBHEX	0000008181810000		; Black pawn   on white square
	NIBHEX	000081C3C0830000		; Black knight on white square
	NIBHEX	0000808181C30000		; Black bishop on white square
	NIBHEX	000042C3C3C30000		; Black rook   on white square
	NIBHEX	00004281C3C30000		; Black queen  on white square
	NIBHEX	000081C381C30000		; Black king   on white square

	NIBHEX	FFFFFFFFFFFFFFFF		; Empty        on black square
	NIBHEX	FFFF3CBDBDBD3CFF		; Black pawn   on black square
	NIBHEX	FF3C99DBD89B38FF		; Black knight on black square
	NIBHEX	FF3EBCBD99DB18FF		; Black bishop on black square
	NIBHEX	FF185ADBDBDB18FF		; Black rook   on black square
	NIBHEX	FF185A99DBDB18FF		; Black queen  on black square
	NIBHEX	FF3C99DB99DB18FF		; Black king   on black square

+	C=RSTK
	A=C	A		; A = piecedata_new

	LC(2)   128
	?D<C	B
	GOYES	pWhite
	D=-D	B
	LC(5)   16*7*2
	A=A+C	A		; Black piece
pWhite	C=B	B
	CSR	B
	C=C+B	P
	?CBIT=0 0
	GOYES	sqWhite
	LC(5)   16*7
	A=A+C	A
sqWhite C=0	A
	C=D	B
	CSL	A
	A=A+C	A
	R0=A			; R0 = start of piece data

	C=B	A
	D=C	A		; D = square

	LC(5)   FLAGS
	D1=D1-	5
	A=DAT1	A
	A=A+C	A
	D0=A
	C=DAT0	B		; C = FLAGS
	D1=D1+	5

	?CBIT=0 OLDPIECES
	GOYES	newPcs
	A=R0
	LC(5)	(piecedata_old)-(piecedata_new)
	A=A+C	A
	R0=A
	C=DAT0	B

newPcs	?CBIT=0 BOARDFLIP
	GOYES	noFlip
	LC(2)   (#21)+(#98)
	D=C-D	B
noFlip	D0=(5)  (=addrVDISP)+2
	A=DAT0	A
	D0=A
	A=DAT0	A		; A = display memory at start row
	LC(5)   20+16
	A=A+C	A

	C=D	B
	B=C	B
	BSR	B		; B = row (2-9)
	B=B+CON B,6
	LC(5)   8*34
LineLp	B=B+1	P
	GOC	+		; if (...) break;
	A=A+C	A
	GOTO	LineLp
+

	C=0	A
	C=D	P
	C=C-1	A
	C=C+C	A
	A=A+C	A
	D0=A			; D0 = display memory at square

	A=R0
	AD1EX
	B=A	A		; B = D1.orig
	LA(5)   34
	P=	16-8
-	C=DAT1	B
	DAT0=C	B
	D1=D1+	2
	CD0EX
	C=C+A	A
	D0=C
	P=P+1
	GONC	-

	A=B	A
	D1=A			; restore D1
	RTN

ENDCODE
