LABEL genmoves

( :: CK2&Dispatch FIFTYONE )       ( BRD INFO -> BRD INFO moves )

:: NULL$ ZERO TOTEMPOB
CODE
* Input:  "BRD" "INFO" "" bint
* Output: "BRD" "INFO" "MOVES" strlen
	GOSBVL	save_regs

	LC(5)   200*16          ; Allocate space for 199 moves
	GOSBVL	make_str
	C=0	A
	DAT0=C	A		; Set used nibble size = 0
	D0=D0-	10

	D1=D1+	5
	AD0EX
	DAT1=A	A

	D1=D1+	10		; D1 = pointer to BRD
	ST=0	WhiteFlag
	LC(5)   COL
	B=C	A
	GOSUBL	GetInfoB
	C=C-1	B
	?C#0	B		; if (COL != 1) goto Black
	GOYES	+
	ST=1	WhiteFlag
+

* B   = pos	= current board position

	LC(5)   #21
	B=C	A

MainLp	GOSUB	GetBrdB
	?C#0	B
	GOYES	NotEmpt
	GOTO	Next		; if (BRD[pos] == 0) continue
NotEmpt LA(1)   7
	?C#A	P
	GOYES	NoBord
	B=B+CON B,8		; if (BRD[pos] == 7) { pos += 8; goto MainLp }
	GOTO	MainLp
NoBord	?ST=1	WhiteFlag
	GOYES	LpVit
	C=-C	B
LpVit	LA(2)   #80
	?C>=A	B
	GOYES	Next

	A=B	A
	R0=A.F	A		; Set argument for CPawn,CKnight, ...

	C=C-1	B
	?C#0	B
	GOYES	Not1
	GOSUB	CPawn
	GOTO	restpos
Not1	C=C-1	B
	?C#0	B
	GOYES	Not2
	GOSUB	CKnight
	GOTO	restpos
Not2	C=C-1	B
	?C#0	B
	GOYES	Not3
	GOSUB	CBish
	GOTO	restpos
Not3	C=C-1	B
	?C#0	B
	GOYES	Not4
	GOSUB	CRook
	GOTO	restpos
Not4	C=C-1	B
	?C#0	B
	GOYES	Not5
	GOSUB	CRook
	GOSUB	CBish
	GOTO	restpos
Not5	GOSUB	CKing

restpos C=R0.F	A
	B=C	A		; Restore pos

Next	B=B+1	B
	LC(2)   #99
	?B>=C	 B
	GOYES	MainEnd
	GOTO	MainLp		; } while (pos < 0x99)

MainEnd GOSUB	FixStr
	GOVLNG	GETPTRLOOP

********************************************************************
* CPawn: Generate all moves for a pawn
*
* Input: D1   = BRD
*	 R0.A = startpos
*
* Destroys: A,B,C,D,D0

CPawn	A=R0.F	A
	LC(2)   #10
	?ST=1	WhiteFlag
	GOYES	Wt_3
	C=-C	B
Wt_3	B=A	B
	B=B+C	B		; B = square in from of pawn

	ASR	B
	LC(1)   8
	?ST=1	WhiteFlag
	GOYES	Wt_2
	LC(1)   3
Wt_2	?C=A	P
	GOYES	DoProm		; No pawn promotion unless row == 7 (or 2)
	GOTO	NoProm

* Pawn promotion

DoProm	GOSUB	GetBrdB
	?C#0	B
	GOYES	Skip_1
	GOSUB	Promote 	; Straight Forward

Skip_1	B=B-1	P
	GOSUB	GetBrdB
	?C=0	B
	GOYES	Skip_2
	LA(1)   7
	?C=A	P
	GOYES	Skip_2
	LA(2)   128
	?ST=0	WhiteFlag
	GOYES	Bl_1
	?C<A	B
	GOYES	Skip_2
	GONC	LProm
Bl_1	?C>A	B
	GOYES	Skip_2
LProm	GOSUB	Promote 	; Forward left

Skip_2	B=B+CON B,2
	GOSUB	GetBrdB
	?C=0	B
	RTNYES
	LA(1)   7
	?C=A	P
	RTNYES
	LA(2)   128
	?ST=0	WhiteFlag
	GOYES	Bl_2
	?C<A	B
	RTNYES
	GOTO	Promote 	; Forward right
Bl_2	?C>A	B
	RTNYES
	GOTO	Promote 	; Forward right

* Straight forward

NoProm	GOSUB	GetBrdB
	?C#0	B
	GOYES	Skip_3
	C=0	W
	C=B	B
	CSL	A
	CSL	A
	C=R0.F	B		; C = [ 0 0 0 0 0 0 to fr ]
	GOSUB	PutMove

	CSR	B
	LA(1)   3
	?ST=1	WhiteFlag
	GOYES	Wt_5
	LA(1)   8
Wt_5	?C#A	P
	GOYES	Skip_3		; Two steps only allow from row 2 (or 7)

	C=B	B
	D=C	B		; D = square in front of pawn

	LC(2)   #10
	?ST=1	WhiteFlag
	GOYES	Wt_6
	C=-C	B
Wt_6	B=B+C	B		; B = square two steps in front of pawn
	GOSUB	GetBrdB
	?C#0	B
	GOYES	No2Step
	C=D	B
	CSL	A
	CSL	A
	LC(1)   2
	CSL	A
	CSL	W
	C=B	B
	CSL	W
	CSL	W
	C=R0.F	B		; C = [ EPsquare 2 to fr ]
	GOSUB	PutMove

No2Step C=D	B
	B=C	B		; B = square in front of pawn

* Left capture

Skip_3	B=B-1	P
	GOSUB	GetBrdB
	?C=0	B
	GOYES	Skip_4
	LA(1)   7
	?C=A	P
	GOYES	Skip_4
	LA(2)   128
	?ST=0	WhiteFlag
	GOYES	Bl_3
	?C<A	B
	GOYES	Skip_4
	GONC	LCapt
Bl_3	?C>A	B
	GOYES	Skip_4
LCapt	CSL	A
	CSL	A
	LC(1)   1
	CSL	A
	CSL	W
	C=B	B
	CSL	W
	CSL	W
	C=R0.F	B		; C = [ piece 1 to fr ]
	GOSUB	PutMove

* Right capture

Skip_4	B=B+CON B,2
	GOSUB	GetBrdB
	?C=0	B
	GOYES	Skip_5
	LA(1)   7
	?C=A	P
	GOYES	Skip_5
	LA(2)   128
	?ST=0	WhiteFlag
	GOYES	Bl_4
	?C<A	B
	GOYES	Skip_5
	GONC	RCapt
Bl_4	?C>A	B
	GOYES	Skip_5
RCapt	CSL	A
	CSL	A
	LC(1)   1
	CSL	A
	CSL	W
	C=B	B
	CSL	W
	CSL	W
	C=R0.F	B		; C = [ piece 1 to fr ]
	GOSUB	PutMove

* EP to the right

Skip_5	C=B	B
	D=C	B		; D = fr+(1,1)
	LC(2)   EPSNT
	B=C	B
	GOSUBL	GetInfoB
	?C#D	B
	GOYES	Skip_6
	C=R0.F	B
	C=C+1	P
	CSL	A
	CSL	A
	LC(1)   3
	CSL	A
	CSL	W
	C=D	B
	CSL	W
	CSL	W
	C=R0.F	B		; C = [ 0 0 0 0 fr+1 3 to fr ]
	GOTO	PutMove

* EP to the left

Skip_6	D=D-CON B,2		; D = fr+(-1,1)
	?C#D	B
	RTNYES
	C=R0.F	B
	C=C-1	P
	CSL	A
	CSL	A
	LC(1)   3
	CSL	A
	CSL	W
	C=D	B
	CSL	W
	CSL	W
	C=R0.F	B		; C = [ 0 0 0 0 fr-1 3 to fr ]
	GOTO	PutMove

********************************************************************
* Promote: Generate all pawn promotions to a given square
*
* Input:  D1   = BRD
*	  B.A  = to
*	  R0.A = from
*	  C.B  = piece	    (captured piece)
*
* Destroys: A,C,D0

Promote CSL	A
	CSL	A
	LC(2)   16+5
	?ST=1	WhiteFlag
	GOYES	Wt_4
	LC(2)   16-5
Wt_4	CSL	A
	CSL	W
	C=B	B
	CSL	W
	CSL	W
	C=R0.F	B		; C = [ 0 0 0 0 piece 16queen to fr ]
	GOSUB	PutMove

	?ST=0	WhiteFlag
	GOYES	BlProm

	P=	4
	LC(1)   2
	GOSUB	PutMove 	; knight
	LC(1)   4
	GOSUB	PutMove 	; rook
	LC(1)   3
	P=	0
	GOTO	PutMove 	; bishop

BlProm	P=	4
	LC(1)   16-2
	GOSUB	PutMove 	; knight
	LC(1)   16-4
	GOSUB	PutMove 	; rook
	LC(1)   16-3
	P=	0
	GOTO	PutMove 	; bishop

********************************************************************
* CKnight: Generate all moves for a knight
*
* Input: D1   = BRD
*	 R0.A = startpos
*
* Destroys: A,B,C,D0

CKnight C=R0.F	A
	D=C	A
	D=D+CON B,16-2		; D = start + (-2,1)
	GOSUB	ChkMv
	LC(2)   16+1
	D=D+C	B		; D = start + (-1,2)
	GOSUB	ChkMv
	D=D+CON B,2		; D = start + (1,2)
	GOSUB	ChkMv
	D=D-CON B,16-1		; D = start + (2,1)
	GOSUB	ChkMv
	LC(2)   32
	D=D-C	B		; D = start + (2,-1)
	GOSUB	ChkMv
	LC(2)   16+1
	D=D-C	B		; D = start + (1,-2)
	GOSUB	ChkMv
	D=D-CON B,2		; D = start + (-1,-2)
	GOSUB	ChkMv
	D=D+CON B,16-1		; D = start + (-2,-1)
	GOTO	ChkMv

********************************************************************
* CKing: Generate all moves for a king
* Input: D1   = BRD
*	 R0.A = startpos
*
* Destroys: A,B,C,D,D0

CKing	C=R0.F	A
	D=C	A
	D=D+CON B,16-1		; D = start + (-1,1)
	GOSUB	ChkMv
	D=D+1	B		; D = start + (0,1)
	GOSUB	ChkMv
	D=D+1	B		; D = start + (1,1)
	GOSUB	ChkMv
	D=D-CON B,16		; D = start + (1,0)
	GOSUB	ChkMv
	D=D-CON B,2		; D = start + (-1,0)
	GOSUB	ChkMv
	D=D-CON B,16		; D = start + (-1,-1)
	GOSUB	ChkMv
	D=D+1	B		; D = start + (0,-1)
	GOSUB	ChkMv
	D=D+1	B		; D = start + (1,-1)
	GOSUB	ChkMv

	A=R0.F	A
	LC(2)   #25
	?ST=1	WhiteFlag
	GOYES	Wt_1
	LC(2)   #95
Wt_1	?A#C	B
	RTNYES			; No castling if king on the wrong square

* Check if king side castling allowed

	LC(5)   TOH1
	?ST=1	WhiteFlag
	GOYES	KVit_1
	LC(2)   TOH8
KVit_1	B=C	A
	GOSUBL	GetInfoB
	?C#0	B
	GOYES	ChkLng

	A=R0.F	B
	B=A	B
	B=B+1	P		; B = f1 (or f8)
	GOSUB	GetBrdB
	?C#0	B
	GOYES	ChkLng		; if (fr+1 != empty) goto ChkLng
	D0=D0+	2
	C=DAT0	B
	?C#0	B
	GOYES	ChkLng		; if (fr+2 != empty) goto ChkLng

	D0=D0+	2
	C=DAT0	B
	LA(2)   4
	?ST=1	WhiteFlag
	GOYES	Kvit_2
	A=-A	B
Kvit_2	?C#A	B
	GOYES	ChkLng		; if (corner square != correct rook) goto ChkLng

* Check for threats against e1 or f1

	B=B-1	P		; B = e1 (or e8)
	GOSUBL	ischeck
	RTNC
	B=B+1	P		; B = f1 (or f8)
	GOSUBL	ischeck
	GOC	ChkLng

* King side castling is allowed

	LC(4)   #0400
	C=B	B
	C=C+1	P		; C = [ 4 to ]
	CSL	A
	CSL	W
	C=B	B
	C=C-1	P		; C = [ 4 to fr ]
	GOSUB	PutMove

* Check if queen side castling is allowed

ChkLng	LC(5)   TOA1
	?ST=1	WhiteFlag
	GOYES	KVit_3
	LC(2)   TOA8
KVit_3	B=C	A
	GOSUBL	GetInfoB
	?C#0	B
	RTNYES

	A=R0.F	B
	B=A	B
	B=B-1	P		; B = d1 (or d8)
	GOSUB	GetBrdB
	?C#0	B
	RTNYES			; if (fr-1 != empty) return
	D0=D0-	2
	C=DAT0	B
	?C#0	B
	RTNYES			; if (fr-2 != empty) return
	D0=D0-	2
	C=DAT0	B
	?C#0	B
	RTNYES			; if (fr-3 != empty) return

	D0=D0-	2
	C=DAT0	B
	LA(2)   4
	?ST=1	WhiteFlag
	GOYES	Kvit_4
	A=-A	B
Kvit_4	?C#A	B
	RTNYES			; if (corner square != correct rook) return

* Check for threats against e1 or d1

	B=B+1	P		; B = e1 (or e8)
	GOSUBL	ischeck
	RTNC
	B=B-1	P		; B = d1 (or d8)
	GOSUBL	ischeck
	RTNC

* Queen side castling is allowed

	LC(4)   #0500
	C=B	B
	C=C-1	P		; C = [ 5 to ]
	CSL	A
	CSL	W
	C=B	B
	C=C+1	P		; C = [ 5 to fr ]
	GOTO	PutMove

********************************************************************
* CRook: Generate all moves for a rook
*
* Input: D1   = pointer to BRD
*	 R0.A = startpos
*
* Destroys: A,B,C,D,D0,R1

CRook	LC(5)   1
	R1=C.F	A
	GOSUB	ChkDir
	LC(5)   0-1
	R1=C.F	A
	GOSUB	ChkDir
	LC(5)   16
	R1=C.F	A
	GOSUB	ChkDir
	LC(5)   0-16
	R1=C.F	A
	GOTO	ChkDir

********************************************************************
* CBish: Generate all moves for a bishop
*
* Input: D1   = pointer to BRD
*	 R0.A = startpos
*
* Destroys: A,B,C,D,D0,R1

CBish	LC(5)   16+1
	R1=C.F	A
	GOSUB	ChkDir
	LC(5)   0-16-1
	R1=C.F	A
	GOSUB	ChkDir
	LC(5)   16-1
	R1=C.F	A
	GOSUB	ChkDir
	LC(5)   0-16+1
	R1=C.F	A
*	 GOTO	 ChkDir

********************************************************************
* ChkDir: Generate all moves in a given direction
*
* Input: D1   = BRD
*	 R0.A = startpos
*	 R1.A = delta
*
* Calls: GetBrdB, PutMove, ChkMv
*
* Destroys: A,B,C,D,D0

* D.A = pos   = Current board square

ChkDir	C=R0.F	A
	D=C	A		; pos = startpos
ChkLp	C=R1.F	A
	D=D+C	A		; pos += delta

	C=D	A
	B=C	A
	GOSUB	GetBrdB
	?C#0	B
	GOYES	ChkMv		; if (BRD[pos] != 0) goto ChkMv

	C=0	W
	C=D	B
	CSL	A
	CSL	A
	C=R0.F	B
	GOSUB	PutMove
	GOTO	ChkLp

********************************************************************
* ChkMv: Check if legal (ie BRD[to] empty or occupied by opponent)
*        to move a piece (not pawn) from one square to another. If so,
*        generate the move. Also handles piece captures.
*
* Input:  D1   = pointer to BRD
*	  R0.A = from
*	  D.A  = to
*
* Calls: GetBrdB, PutMove
*
* Destroys: A,B,C,D0

ChkMv	C=D	A
	B=C	A
	GOSUB	GetBrdB 	; C = [ ext2 ]
	?C=0	B
	GOYES	ChkNHit 	; if (BRD[to] == 0) goto ChkNHit
	LA(1)   7
	?A=C	P
	RTNYES			; if (BRD[to] == 7) return
	LA(2)   #80
	?ST=1	WhiteFlag
	GOYES	ChkVit		; if (WhiteFlag == TRUE) goto ChkVit
	?C<A	B
	GOYES	ChkOk		; if (BRD[to] > 0) goto ChkOk
	RTN
ChkVit	?C<A	B
	RTNYES			; if (BRD[to] > 0) return

ChkOk	CSL	A
	CSL	A
	LC(1)   1               ; C = [ext2 1]
	CSL	A
	CSL	W
	C=D	B		; C = [ext2 1 to]
	CSL	W
	CSL	W
	C=R0.F	B		; C = [0 0 0 0 ext2 ext1 from to]
	GOTO	PutMove

ChkNHit C=0	A
	C=D	B		; C = [ 0 to ]
	CSL	A
	CSL	W
	C=R0.F	B		; C = [ 0 to fr ]
*	 GOTO	 PutMove

********************************************************************
* PutMove: Save a move in the MOVE-string
*
* Input: D1  = BRD
*	 C.W = move
*	 P   = godtycklig
*
* Destroys: A,D0

PutMove D1=D1-	10
	A=DAT1	A
	D0=A
	D0=D0+	10		; D0 = &moves[0]

	A=DAT0	A
	A=A+CON A,16
	DAT0=A	A		; niboffs += 16

	CD0EX
	C=C+A	A
	CD0EX			; D0 = &moves[niboffs/16]
	DAT0=C	8

	D1=D1+	10
	RTN

********************************************************************
* GetBrdB: Read a board position
*
* Input:  D1  = BRD
*	  B.A = pos
*
* Output: C.B = BRD[pos]
*	  D0  = target address

GetBrdB D0=A
	A=DAT1	A
	A=A+B	A
	A=A+B	A
	AD0EX
	D0=D0+	10
	C=DAT0	B
	RTN

********************************************************************
* FixStr: Remove niboffs and save strlen on stack
*
* Input: D1  = BRD
*
* Destroys: A,B,C,D0

FixStr	D1=D1-	10
	A=DAT1	A
	D0=A
	D0=D0+	10		; D0 = &moves[0]

	A=DAT0	A
	B=A	A		; B = niboffs
	AD0EX
	A=A+B	A
	D0=A			; D0 = &moves[niboffs/16]
	C=DAT0	W
	A=A-B	A
	D0=A
	DAT0=C	W		; moves[0] = moves[niboffs/16]

	C=B	A
	CSRB.F	A
	C=C+1	A		; Compensate for 1_#1-SUB$
	D1=D1-	5
	A=DAT1	A
	D0=A
	D0=D0+	5
	DAT0=C	A		; Set #strlen on stack

	D1=D1+	15
	RTN

ENDCODE
  1_#1-SUB$
;
