#include <stdio.h>
#include "types.h"

UBYTE board[12 * 16];

int main(int argc, char *argv[])
{
    FILE *file;
    int x, y, p;
    char buffer[16];

    if (argc != 2) {
	printf("Usage: PrintBoard filename\n");
	return 0;
    }
    if ((file = fopen(argv[1], "r")) == 0) {
	printf("Cannot open file '%s'\n", argv[1]);
	return 0;
    }
    if (fread(buffer, 1, 13, file) != 13) {
	printf("Cannot read HP header\n");
	fclose(file);
	return 0;
    }
    if (fread(board, 1, 12 * 16, file) != 12 * 16) {
	printf("Cannot read board data\n");
	fclose(file);
	return 0;
    }
    fclose(file);

    printf("\n");
    for (y = 9; y >= 2; y--) {
	printf("\033[31m\033[40m      ");
	for (x = 1; x <= 8; x++) {
	    if ((x + y) & 1)
		printf("\033[43m");
	    else
		printf("\033[40m");
	    p = board[y * 16 + x];
	    if (p >= 128)
		p -= 256;
	    if (p > 0) {
		printf("\033[32m");
	    } else {
		printf("\033[31m");
		p = -p;
	    }
	    printf(" ");
	    switch (p) {
	    case 1:
		printf("p");
		break;
	    case 2:
		printf("N");
		break;
	    case 3:
		printf("B");
		break;
	    case 4:
		printf("R");
		break;
	    case 5:
		printf("Q");
		break;
	    case 6:
		printf("K");
		break;
	    default:
		printf(" ");
		break;
	    }
	    printf(" ");
	}
	printf("\n");
    }
    printf("\033[31m\033[40m\n");
    return 0;
}
