LABEL search

* Search: Calculate negamax score for a given position
*
* Stack: (BRD INFO -> BRD INFO)
*
* Output: HI	    = score for this position
*		      HI >= INFTY     iff king can be captured
*		      HI = 0	      if draw or stalemate
*		      HI =  -INFTY/2  if side to move is checkmated.
*	  best[ply] = best move (If a legal move exists)

( :: CK2&Dispatch FIFTYONE )       ( BRD INFO -> BRD INFO )

::
  INCLUDE genmoves.s
  INCLUDE bfirst.s
  INCLUDE stateval.s
  ::
    DUPNULL$? ?SEMI
    INCLUDE sortmoves.s
    CODE
      CALL  bfirst
    ENDCODE
    "1234567" TOTEMPOB 4UNROLL
    BEGIN
      UNROT

      CODE
* Input: (savestr moves BRD INFO )

* ply++
* SaveVars()    (hi,goal,legal)
* / hi \   /-goal\
* \goal/ = \ -hi /
* glscore = -(glscore + statscore)

	GOSBVL	SAVPTR
	D1=D1+	10
	C=DAT1	A
	D0=C
	D0=D0+	10
	C=DAT0	8
	R0=C			; R0 = move
	D1=D1-	10		; D1 -> INFO
	GOSUB	mkmv

	LA(5)   PLY
	C=DAT1	A
	C=C+A	A
	D0=C

	C=DAT0	B
	C=C+1	B
	DAT0=C	B		; ply++

	D0=D0+	(HI)-(PLY)
	C=DAT0	(GLSCORE)-(HI)
	D1=D1+	15
	A=DAT1	A
	D1=D1-	15
	AD0EX
	D0=D0+	10
	DAT0=C	(GLSCORE)-(HI)  ; SaveVars()

	D0=A
	C=DAT0	A
	C=-C	A		; C = -hi
	D0=D0+	(GOAL)-(HI)
	A=DAT0	A
	A=-A	A		; A = -goal
	DAT0=C	A		; goal = C
	D0=D0-	(GOAL)-(HI)
	DAT0=A	A		; hi = A

	D1=D1+	10
	A=DAT1	A
	D1=D1-	10
	AD0EX
	D0=D0+	10
	D0=D0+	8
	C=DAT0	A		; C = statscore
	D0=A
	D0=D0+	(GLSCORE)-(HI)
	A=DAT0	A
	A=A+C	A
	A=-A	A
	DAT0=A	A		; glscore = -(glscore + statscore)

	GOVLNG	rest_loop

	INCLUDE mkmv.s
      ENDCODE

      CODE
	CALL  search
      ENDCODE
      3PICK

      CODE
* Input: (savestr moves BRD INFO move)

* ply--
* score = -hi
* RestVars()  (hi,goal,legal)
*
* if (score > hi) {
*   hi = score; best[ply] = move;
*   if (hi >= goal) moves = "";
* }
* glscore = (-glscore) - statscore

	GOSBVL	save_regs

	D1=D1+	5		; D1 -> INFO
	LA(5)   PLY
	C=DAT1	A
	C=C+A	A
	D0=C

	C=DAT0	B
	C=C-1	B
	DAT0=C	B		; ply--

	D0=D0+	(HI)-(PLY)
	C=DAT0	A
	D=C	A
	D=-D	A		; D = score = -hi
	D1=D1+	15
	A=DAT1	A
	D1=D1-	15
	AD0EX
	D0=D0+	10
	C=DAT0	(GLSCORE)-(HI)
	D0=A
	DAT0=C	(GLSCORE)-(HI)  ; RestVars()

	LC(5)   INFTY
	C=C+D	A		; C = score + INFTY
	LA(5)   #80000
	?C<A	A
	GOYES	+		; if (C >= 0) goto IsLegal
	GOTO	notbest
+	D0=D0+	(LEGAL)-(HI)
	C=DAT0	B
	C=C+1	B
	DAT0=C	B		; legal++
	D0=D0-	(LEGAL)-(HI)

	C=DAT0	A
	C=C-D	A		; C = hi - score
	LA(5)   #80000
	?C>=A	 A
	GOYES	best

	GOTO	notbest
best	C=D	A
	DAT0=C	A		; hi = score

	D1=D1+	10
	A=DAT1	A
	D1=D1-	10
	D0=A
	D0=D0+	10
	A=DAT0	8
	B=A	W		; B = move
	C=DAT1	A
	LA(5)   MOVE0
	C=C+A	A
	D=C	A		; D = &info[MOVE0]
	LA(2)   (MOVE0)-(PLY)
	C=C-A	A
	D0=C
	C=0	A
	C=DAT0	B
	C=C+C	B
	C=C+C	B
	C=C+C	B		; C = 8 * PLY
	C=C+D	A
	D0=C			; D0 = &info[MOVE0+8*PLY]
	C=B	W
	DAT0=C	8		; best[ply] = move

	LA(5)   HI
	C=DAT1	A
	C=C+A	A
	D0=C
	C=DAT0	A
	D=C	A		; D = hi
	D0=D0+	(GOAL)-(HI)
	C=DAT0	A		; C = goal
	D0=D0-	(GOAL)-(HI)
	C=C-D	A
	?C=0	A
	GOYES	goal		; if (hi == goal) goto goal
	LA(5)   #80000
	?C<A	A
	GOYES	notbest 	; if (hi < goal) goto notbest
goal	D1=D1+	10
	LC(5)   =NULL$
	DAT1=C	A		; moves = ""
	D1=D1-	10

* Requires that D0 = &info[hi]

notbest D1=D1-	5
	A=DAT1	A
	D1=D1+	5
	AD0EX
	D0=D0+	10
	D0=D0+	8
	C=DAT0	A		; C = statscore
	D0=A
	D0=D0+	(GLSCORE)-(HI)
	A=DAT0	A
	A=-A	A
	A=A-C	A
	DAT0=A	A		; glscore = (-glscore) - statscore

	GOSBVL	GETPTR
	A=DAT1	A
	D0=A
	D0=D0+	10
	C=DAT0	8
	R0=C			; R0 = [ext2 ext1 to fr] (4 bytes)
	D1=D1+	5		; D1 -> INFO

	GOSUB	unmkmv

	GOVLNG	GETPTRLOOP

	INCLUDE unmkmv.s
      ENDCODE

      DROP

      ROT NINE OVERLEN$ SUB$

      DUPNULL$?
    UNTIL
    4ROLLDROP
  ; DROP
  CODE
* Input: (BRD INFO)     ; Check for mate and stale mate
	GOSBVL	save_regs

	A=DAT1	A
	LC(5)   LEGAL
	A=A+C	A
	D0=A
	A=DAT0	B		; A = legal
	?A#0	B
	GOYES	MPDone

NoMoves ST=1	WhiteFlag
	LC(2)   COL
	B=0	A
	B=C	B

	A=DAT1	A
	A=A+B	A
	D0=A
	C=DAT0	B		; C = COL
	D1=D1+	5		; D1 -> BRD

	LA(5)   (VKNG)-(COL)
	C=C-1	B
	?C=0	B
	GOYES	NMWhite
	ST=0	WhiteFlag
	A=A+CON B,(SKNG)-(VKNG)
NMWhite CD0EX
	C=C+A	A
	CD0EX
	C=DAT0	B
	B=C	B		; B = own king position
	GOSUB	ischeck
	GONC	Patt

Matt	LC(2)   HI
	B=0	A
	B=C	B
	LC(5)   0-(INFTY)/2
	GOSUB	PutInfoI	; hi = -INFTY/2
	GOTO	MPDone

Patt	LC(2)   HI
	B=0	A
	B=C	B
	C=0	A
	GOSUB	PutInfoI	; hi = 0

MPDone	GOVLNG	rest_loop

********************************************************************
* PutInfoI: Write an INT to INFO
*
* Input:  D1  = BRD
*	  B.A = offset (i nibbles)
*	  C.A = data
*
* Output: D0  = target address
*
* Destroys: A

PutInfoI
	D1=D1-	5
	A=DAT1	A
	A=A+B	A
	D0=A
	DAT0=C	A
	D1=D1+	5
	RTN

********************************************************************
* ischeck: Check if a square is threatened by the opponent
*
* Input:  D1  = BRD
*	  B.A = pos (square to check)
*	  ST.WhiteFlag = TRUE if white to move
*
* Output: Carry = TRUE if square is threatened
*
* Destroys: A,C,D,D0

ischeck LC(5)   2*1
	D=C	A
	GOSUB	scandir 	; (0,1)
	RTNC
	LA(1)   4
	?A=C	P
	RTNYES
	D=-D	A
	GOSUB	scandir 	; (0,-1)
	RTNC
	LA(1)   4
	?A=C	P
	RTNYES

	LC(5)   2*16
	D=C	A
	GOSUB	scandir 	; (1,0)
	RTNC
	LA(1)   4
	?A=C	P
	RTNYES
	D=-D	A
	GOSUB	scandir 	; (-1,0)
	RTNC
	LA(1)   4
	?A=C	P
	RTNYES

	LC(5)   2*(16+1)
	D=C	A
	GOSUB	scandir 	; (1,1)
	RTNC
	LA(1)   3
	?A=C	P
	RTNYES
	D=-D	A
	GOSUB	scandir 	; (-1,-1)
	RTNC
	LA(1)   3
	?A=C	P
	RTNYES

	LC(5)   2*(16-1)
	D=C	A
	GOSUB	scandir 	; (1,-1)
	RTNC
	LA(1)   3
	?A=C	P
	RTNYES
	D=-D	A
	GOSUB	scandir 	; (-1,1)
	RTNC
	LA(1)   3
	?A=C	P
	RTNYES

	LC(2)   2
	?ST=0	WhiteFlag
	GOYES	ischBl
	C=-C	B
ischBl	D=C	B		; D = opponent knight
	GOSUBL	GetBrdB
	AD0EX
	LC(5)   2*(2*16-1)
	A=A+C	A
	AD0EX			; (-1,2)
	C=DAT0	B
	?C=D	B
	RTNYES

	D0=D0+	2*2		; (1,2)
	C=DAT0	B
	?C=D	B
	RTNYES

	D0=D0-	16-1
	D0=D0-	16-1		; (2,1)
	C=DAT0	B
	?C=D	B
	RTNYES

	D0=D0-	2*4		; (-2,1)
	C=DAT0	B
	?C=D	B
	RTNYES

	AD0EX
	LC(5)   2*(0-2*16)
	A=A+C	A
	AD0EX			; (-2,-1)
	C=DAT0	B
	?C=D	B
	RTNYES

	D0=D0+	2*4		; (2,-1)
	C=DAT0	B
	?C=D	B
	RTNYES

	AD0EX
	LC(5)   2*(0-16-3)
	A=A+C	A
	AD0EX			; (-1,-2)
	C=DAT0	B
	?C=D	B
	RTNYES

	D0=D0+	2*2		; (1,-2)
	C=DAT0	B
	?C=D	B
	RTNYES

* Check opponent pawn threats

	GOSUBL	GetBrdB 	; D0 = &BRD[pos]

	LC(5)   2*(16-1)
	?ST=1	WhiteFlag
	GOYES	White_1
	LC(5)   2*(0-16-1)
White_1	AD0EX
	A=A+C	A
	AD0EX			; D0 = &BRD[ pos + (1 forward) + (1 left) ]

	C=DAT0	B
	?ST=1	WhiteFlag
	GOYES	White_2
	C=-C	B
White_2	C=C+1	B
	?C=0	B
	RTNYES			; if (BRD[pos+(1,-1)] == opponent pawn) return TRUE;

	D0=D0+	2*2
	C=DAT0	B
	?ST=1	WhiteFlag
	GOYES	White_3
	C=-C	B
White_3	C=C+1	B
	?C=0	B
	RTNYES			; if (BRD[pos+(1,1)] == opponent pawn) return TRUE;

	LC(5)	VKNG
	?ST=0	WhiteFlag
	GOYES	+
	LC(2)	SKNG
+	D1=D1-	5
	A=DAT1	A
	D1=D1+	5
	A=A+C	A
	D0=A
	C=DAT0	B		; C = enemy king position
	A=B	B
	GOSUBL	Dist
	C=C-1	A
	?C=0	A
	RTNYES			; if (distance(eking,pos) == 1) return TRUE;

	RTNCC

********************************************************************
* scandir: Find first piece in a given direction
*
* Input:  D1  = BRD
*	  B.A = pos
*	  D.A = delta  (in nibbles)
*	  ST.WhiteFlag = TRUE if white to move
*
* Output: C.B = piece (>0 if opponent piece)
*	  Carry = TRUE if quare is threatened by a queen in this direction.
*
* Destroys: A,D0

scandir GOSUBL	GetBrdB
scanLp	CD0EX
	C=C+D	A
	CD0EX			; D0 += delta
	C=DAT0	B
	?C=0	B
	GOYES	scanLp

	?ST=0	WhiteFlag
	GOYES	scanBl
	C=-C	B
scanBl	LA(1)   5
	?C=A	P
	RTNYES			; if (opponent queen) return(TRUE)
	RTN			; else return(FALSE)

  ENDCODE
;
