LABEL sortmoves

( :: CK1&Dispatch str )

CODE				; Sort MOVE-vector according to score (shell sort)
	GOSBVL	save_regs

* D1 =		= &moves[0]
* B  = j	= Inner loop variable
* D  = tmpscore = Current score (Used in InnerLp)
* R0 = h	= Step length in shell sort algorithm (Sequence is 13,4,1)
* R1 = i	= Outer loop variable
* R2 = tmpmove	= Current move
* R3 = N	= Vector length		(i,j,h,N are counted in nibbles)

	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A
	A=A-CON A,5
	R3=A.F	A		; N = vector length in nibbles
	D1=D1+	5		; D1 = &moves[0]

	GOSUB	ShiftSc

	LC(5)   13*16
	R0=C.F	A		; h = 13

Loop_H	C=R0.F	A
	R1=C.F	A		; i = h
Loop_I	A=R1.F	A
	C=R3.F	A
	?A<C	A
	GOYES	cont_H		; while (i < N)
	GOTO	Next_H

cont_H	AD1EX
	D1=A
	C=R1.F	A
	B=C	A		; j = i
	A=A+C	A
	D0=A
	C=DAT0	W
	R2=C			; tmpmove = moves[i]
	D0=D0+	8
	C=DAT0	A
	D=C	A		; tmpscore = moves[i].score

InnerLp C=R0.F	A
	?B<C	A
	GOYES	EndLp		; if (j < h) break;

	AD1EX
	D1=A
	A=A+B	A
	A=A-C	A
	D0=A			; D0 = A = &moves[j-h]

	D0=D0+	8
	C=DAT0	A
	?C>=D	A
	GOYES	EndLp		; if (moves[j-h].score >= tmpscore) break;

	D0=D0-	8
	C=R0.F	A
	A=A+C	A		; A = &moves[j]
	B=B-C	A		; j -= h
	C=DAT0	W
	D0=A
	DAT0=C	W		; moves[j] = moves[j-h]

	GOTO	InnerLp

EndLp	AD1EX
	D1=A
	A=A+B	A
	D0=A
	C=R2
	DAT0=C	W		; a[j] = v

Next_I	C=R1.F	A
	C=C+CON A,16
	R1=C.F	A		; i++
	GOTO	Loop_I

Next_H	C=R0.F	A
	LA(5)   13*16
	?A#C	B
	GOYES	not13
	LC(2)   4*16
	R0=C.F	A
	GOTO	Loop_H
not13	LA(2)   4*16
	?A#C	B
	GOYES	not_4
	LC(2)   1*16
	R0=C.F	A
	GOTO	Loop_H

not_4	GOSUB	ShiftSc
	GOVLNG	rest_loop

********************************************************************
* ShiftSc: Add 2^19 to all scores, so that they can be compared as
*          if unsigned. Calling this routine twice is a no op, because
*          the scores are saved as 20 bit values.
*
* Input:  D1   = &moves[0]
*	  R3.A = N
* Destroys: A,C,D,D0

* A  = i	= loop variable, counts down to 0
* D  = scoffs	= 2^19, makes it possible to do unsigned comparisons
* D0 = ptr	= current move

ShiftSc AD1EX
	D1=A
	D0=A
	D0=D0+	8		; ptr = &moves[0].score
	LC(5)   #80000
	D=C	A		; scoffs = 2^19
	A=R3.F	A
	ASR	A		; A = # of moves

ShLoop	?A=0	B
	RTNYES			; if (i == 0) return
	C=DAT0	A
	C=C+D	A
	DAT0=C	A		; moves[i].score += scoffs
ShNext	A=A-1	B		; i--
	D0=D0+	16		; ptr += 16 nibbles
	GOTO	ShLoop

ENDCODE
