********************************************************************
* unmkmv: Take back a move and update info. Note that the EPSNT
*         square is set to zero, not restored to its previous value.
*
* Input:  D1  = INFO
*	  R0  = move
*
* Output:
*
* Destroys: A,B,C,D,D0,R1

unmkmv	B=0	A

	A=R0
	ASR	A
	ASR	A
	B=A	B
	GOSUB	GetBrdI 	; tmp = BRD[to]
	R1=C			; R1 = Piece

	ST=1	WhiteFlag
	LA(2)   128
	?C<A	B
	GOYES	+		; GOYES   WhiteMv
	ST=0	WhiteFlag

+	D=C	A
	C=0	A
	GOSUB	PutBrd		; BRD[to] = 0
	A=R0
	B=A	B
	C=D	A
	GOSUB	PutBrd		; BRD[fr] = tmp

	LC(2)   EPSNT
	B=C	B
	C=0	A
	GOSUB	PutInfoB	; EPSNT = 0

	D0=D0-	(EPSNT)-(COL)
	C=DAT0	B
	C=-C	B
	DAT0=C	B		; COL = -COL

* Check if to = a1,e1,h1, a8,e8,h8

	A=R0
	ASR	A
	ASR	A
	LC(2)   #21             ; a1
	?C#A	B
	GOYES	+
	LC(2)   TOA1
	GOSUB	DecInfo
	GOTO	u_ChkKng

+	LC(2)   #25             ; e1
	?C#A	B
	GOYES	+
	LC(2)   TOA1
	GOSUB	DecInfo
	LC(2)   TOH1
	GOSUB	DecInfo
	GOTO	u_ChkKng

+	LC(2)   #28             ; h1
	?C#A	B
	GOYES	+
	LC(2)   TOH1
	GOSUB	DecInfo
	GOTO	u_ChkKng

+	LC(2)   #91             ; a8
	?C#A	B
	GOYES	+
	LC(2)   TOA8
	GOSUB	DecInfo
	GOTO	u_ChkKng

+	LC(2)   #95             ; e8
	?C#A	B
	GOYES	+
	LC(2)   TOA8
	GOSUB	DecInfo
	LC(2)   TOH8
	GOSUB	DecInfo
	GOTO	u_ChkKng

+	LC(2)   #98             ; h8
	?C#A	B
	GOYES	u_ChkKng
	LC(2)   TOH8
	GOSUB	DecInfo

* If king has moved, update king positions

u_ChkKng
	A=R1
	LC(2)   6
	?A#C	B
	GOYES	+
	LC(2)   VKNG
	GOSHORT u_SetKing
+	LC(2)   256-6
	?A#C	B
	GOYES	u_NotSKng
	LC(2)   SKNG
u_SetKing
	B=C	B
	C=R0
	GOSUB	PutInfoB	; XKNG = fr

* Check ext1

u_NotSKng
	A=R0
	ASR	W
	ASR	W
	ASR	W
	ASR	W		; A = [ext2 ext1]
	C=0	A
	?A#C	B
	GOYES	+
	GOTO	u_AllDone

+	C=C+1	A
	?A#C	B
	GOYES	u_not1

	C=R0
	CSR	A
	CSR	A
	B=C	B
	C=A	A
	CSR	A
	CSR	A
	D=C	A		; D = ext2
	GOSUB	PutBrd		; BRD[to] = ext2

	C=D	A
	A=C	A
	LC(2)   SMTL
	?ST=1	WhiteFlag
	GOYES	+
	LC(2)   VMTL
+	B=C	B
	GOTO	MtlAdd

u_not1	C=C+1	A
	?A#C	B
	GOYES	u_not2
	GOTO	u_AllDone

u_not2	C=C+1	A
	?A#C	B
	GOYES	u_not3

	ASR	A
	ASR	A
	B=A	B
	C=R1
	C=-C	B		; Change colors
	GOSUB	PutBrd		; BRD[ext2] = pawn

	LC(2)   SMTL
	?ST=1	WhiteFlag
	GOYES	+
	LC(2)   VMTL
+	B=C	B
	A=0	A
	A=A+1	A
	GOTO	MtlAdd

u_not3	C=C+1	A
	?A#C	B
	GOYES	u_not4

	A=R0
	B=A	B
	B=B+1	A
	GOSUB	GetBrdI 	; tmp = BRD[fr+1]
	D=C	A
	C=0	A
	GOSUB	PutBrd		; BRD[fr+1] = 0
	B=B+CON B,2
	C=D	A
	GOSUB	PutBrd		; BRD[fr+3] = tmp
	GOTO	u_AllDone

u_not4	C=C+1	A
	?A#C	B
	GOYES	u_not5

	A=R0
	B=A	B
	B=B-1	A
	GOSUB	GetBrdI 	; tmp = BRD[fr-1]
	D=C	A
	C=0	A
	GOSUB	PutBrd		; BRD[fr-1] = 0
	B=B-CON B,3
	C=D	A
	GOSUB	PutBrd		; BRD[fr-4] = tmp
	GOTO	u_AllDone

u_not5	A=A-CON B,16		; Promotion piece = ext1-16
	C=A	A
	D=C	A		; D = [ext2 ext1-16]
	CSR	A
	CSR	A
	A=R0
	ASR	A
	ASR	A
	B=A	B
	GOSUB	PutBrd		; BRD[to] = ext2

	A=R0
	B=A	B
	LC(2)   1
	?ST=1	WhiteFlag
	GOYES	+
	LC(2)   256-1
+	GOSUB	PutBrd		; BRD[fr] = pawn

	C=D	A
	A=C	A
	GOSUB	Gtml
	B=C	A		; B = value(ext1-16)
	A=0	A
	A=A+1	A
	GOSUB	Gtml
	B=B-C	A		; B = value(ext1-16)-value(pawn)
	LC(5)   VMTL
	?ST=1	WhiteFlag
	GOYES	+
	LC(2)   SMTL

+	A=DAT1	A
	A=A+C	A
	D0=A
	C=DAT0	A
	C=C-B	A
	DAT0=C	A		; MTL -= value

	LC(5)   SMTL
	?ST=1	WhiteFlag
	GOYES	+
	LC(2)   VMTL
+	B=C	A
	C=D	A
	A=C	A
	ASR	A
	ASR	A
MtlAdd	GOSUB	Gtml

	A=DAT1	A
	A=A+B	A
	D0=A
	A=DAT0	A
	A=A+C	A
	DAT0=A	A		; XMTL += (captured piece)

u_AllDone
	RTN

********************************************************************
* DecInfo: info[pos]--
*
* Input:  D1  = INFO
*	  C.A = offset
*
* Destroys: A,C,D0

DecInfo A=DAT1	A
	A=A+C	A
	D0=A
	C=DAT0	B
	C=C-1	B
	DAT0=C	B
	RTN
